export class Exception {
    /**
     * @param message is JavaScript original message, in English usually.
     * In prod environment, you are not advised to display the error message directly to end-user.
     */
    constructor(message) {
        this.message = message;
    }
}
export class APIException extends Exception {
    constructor(message, statusCode, requestURL, responseData, errorId, errorCode) {
        super(message);
        this.statusCode = statusCode;
        this.requestURL = requestURL;
        this.responseData = responseData;
        this.errorId = errorId;
        this.errorCode = errorCode;
    }
}
export class NetworkConnectionException extends Exception {
    constructor(message, requestURL, originalErrorMessage = "") {
        super(message);
        this.requestURL = requestURL;
        this.originalErrorMessage = originalErrorMessage;
    }
}
export class JavaScriptException extends Exception {
    constructor(message, originalError) {
        super(message);
        this.originalError = originalError;
    }
}
//# sourceMappingURL=Exception.js.map